{

raVen's ini engine
(c) 2000 by raVen

supported compilers: borland pascal 7.x, virtual pascal 2.0b+

}
{&Use32+,LocInfo+}
{$D+,L+,I-,R-,S-,Q-}
{}
Unit rIni;
interface
Uses Objects;
{}
const
{}
 iTrue : pChar = 'Yes';
 iFalse: pChar = 'No';
{ snDefault: pChar = 'Default';}
{}
type
{( tIniKey )}
 pIniKey = ^tIniKey;
 tIniKey = object(tObject)
  Name, Value: pString;
  constructor Init(aName,aValue: String);
  destructor  Done; virtual;
 end;
{( tIniSection )}
 pIniSection = ^tIniSection;
 tIniSection = object(tObject)

  ValueError: Boolean;

  constructor Init(aName: String);
  destructor  Done; virtual;

  procedure AddKey(aName, aValue: String);

  function ExistValue(ValueName: String): Integer;

  procedure FindValue(First: Boolean; var ValueName, Value: String);

 priVate
  Name: pString;
  KeyCol: pCollection;
  cv: Integer;
 end;
{( tIniFile )}
 pIniFile = ^tIniFile;
 tIniFile = object(tObject)

  SectionError: Boolean;
  ValueError: Boolean;

  constructor Init;
  destructor  Done; virtual;

  function LoadFile(aFileName: String): Byte;
  function LoadFileEx(aFileName: String): Byte;
  function SaveFile(aFileName: String): Byte;
  function SaveFileEx(aFileName: String): Byte;

  function ExistSection(SectionName: String): Integer;
  function ExistValue(SectionName, ValueName: String): Boolean;

  procedure FindSection(First: Boolean; var SectionName: String);

  procedure FindValue(First: Boolean; SectionName: String; var ValueName, Value: String);

  function ReadBoolean(SectionName, ValueName: String): Boolean;
  function ReadInteger(SectionName, ValueName: String): Longint;
  function ReadString(SectionName, ValueName: String): String;

  procedure WriteBoolean(SectionName, ValueName: String; aValue: Boolean);
  procedure WriteInteger(SectionName, ValueName: String; aValue: Longint);
  procedure WriteString(SectionName, ValueName: String; aValue: String);

  procedure DeleteValue(SectionName, ValueName: String);
  procedure DeleteSection(SectionName: String);
  procedure DeleteSections;

 priVate
  SecCol: pCollection;
  FileName: pString;
  cs: Integer;
  Modified: Boolean;
 end;
{( tIniFiles )}
 pIniFiles = ^tIniFiles;
 tIniFiles = object(tObject)

  SectionError: Boolean;
  ValueError: Boolean;

  constructor Init;
  destructor  Done; virtual;

  function ExistSection(IniFileName, SectionName: String): Boolean;
  function ExistValue(IniFileName, SectionName, ValueName: String): Boolean;

  procedure FindSection(First: Boolean; IniFileName: String; var SectionName: String);

  procedure FindValue(First: Boolean; IniFileName: String; SectionName: String; var ValueName, Value: String);

  function ReadBoolean(IniFileName, SectionName, ValueName: String): Boolean;
  function ReadInteger(IniFileName, SectionName, ValueName: String): Longint;
  function ReadString(IniFileName, SectionName, ValueName: String): String;

  procedure WriteBoolean(IniFileName, SectionName, ValueName: String; aValue: Boolean);
  procedure WriteInteger(IniFileName, SectionName, ValueName: String; aValue: Longint);
  procedure WriteString(IniFileName, SectionName, ValueName: String; aValue: String);

  procedure DeleteValue(IniFileName, SectionName, ValueName: String);
  procedure DeleteSection(IniFileName, SectionName: String);
  procedure DeleteSections(IniFileName: String);

 priVate
  IniCol: pCollection;
  function GetIniFileByName(IniFileName: String): pIniFile;
 end;
{}
implementation
Uses rStrings, rCommon, rObjects, Strings;
{( tIniKey )}
constructor tIniKey.Init;
 begin
  Name:=NewStr(aName);
  Value:=NewStr(aValue);
 end;
{}
destructor tIniKey.Done;
 begin
  ReallocStr(Name,'');
  ReallocStr(Value,'');
 end;
{( tIniKey )}
constructor tIniSection.Init;
 begin
  Name:=NewStr(aName);
  New(KeyCol,Init(16,16));
  cv:=MaxInt;
  ValueError:=True;
 end;
{}
destructor tIniSection.Done;
 begin
  ReallocStr(Name,'');
  DisposeObj(KeyCol);
 end;
{}
procedure tIniSection.AddKey;
 begin
  KeyCol^.Insert(New(pIniKey,Init(aName,aValue)));
 end;
{}
function tIniSection.ExistValue;
 var
  x: Integer;
 begin
  with KeyCol^ do if Count>0 then for x:=0 to Count-1 do
  if (UpStr(GetPS(pIniKey(At(X))^.Name))=UpStr(ValueName)) then
   begin
    ExistValue:=x;
    exit;
   end;
  ExistValue:=-1;
 end;
{}
procedure tIniSection.FindValue;
 begin
  if First then cv:=-1;
  Inc(cv);
  ValueName:='';
  Value:='';
  with KeyCol^ do if Count-1>=cv then
   begin
    ValueName:=GetPS(pIniKey(At(cv))^.Name);
    Value:=GetPS(pIniKey(At(cv))^.Value);
    ValueError:=False;
   end else ValueError:=True;
 end;
{( tIniFile )}
constructor tIniFile.Init;
 begin
  New(SecCol,Init(16,16));
  FileName:=nil;
  cs:=MaxInt;
  ValueError:=True;
  SectionError:=True;
  Modified:=False;
 end;
{}
destructor tIniFile.Done;
 begin
  DisposeObj(SecCol);
  ReallocStr(FileName,'');
 end;
{}
function tIniFile.LoadFile;
 var
  f: pStream;
  vn,v,CurrentSection,s: String;
  x: Integer;
  iss: pIniSection;
 begin
  iss:=nil;
  LoadFile:=1;
  ReallocStr(FileName,aFileName);
  if not Exist(aFileName) then exit;
  f:=New(pBufStream,Init(aFileName,stOpenRead,BlockSize));
  CurrentSection:='';
  while (f^.GetSize<>f^.GetPos) do
   begin
   StreamReadLn(f^,s);
   s:=Trim(s,SpaceChars);
   if (Length(s)>1) and (s[1]=qBracket1) then
    begin
     CurrentSection:=ExtractWord(1,s,[qBracket1,qBracket2]);
{     if Trim(CurrentSection,SpaceChars)='' then CurrentSection:=StrPas(snDefault);}
     x:=ExistSection(CurrentSection);
     if x<0 then
      begin
       New(iss,Init(CurrentSection));
       SecCol^.Insert(iss);
      end
     else iss:=SecCol^.At(x);
     continue;
    end;
   if (iss=nil) then
    begin
     New(iss,Init(CurrentSection));
     SecCol^.Insert(iss);
    end;
    s:=Space+s+Space;
    vn:=Trim(ExtractWord(1,s,[Equation]),SpaceChars);
    if (Pos(Equation,s)=0) then v:='' else
    v:=Trim(Copy(s,Pos(Equation,s)+1,Length(s)),SpaceChars);
    iss^.AddKey(vn,v);
   end;
  DisposeObj(f);
  Modified:=False;
  LoadFile:=0;
 end;
{}
function tIniFile.LoadFileEx;
 var
  f: Text;
  vn,v,CurrentSection,s: String;
  x: Integer;
  iss: pIniSection;
 begin
  iss:=nil;
  LoadFileEx:=1;
  ReallocStr(FileName,aFileName);
  if not Exist(aFileName) then exit;
  Assign(f,aFileName);
  Reset(f);
  CurrentSection:='';
  while (not Eof(f)) do
   begin
   ReadLn(f,s);
   s:=Trim(s,SpaceChars);
   if (Length(s)>1) and (s[1]=qBracket1) then
    begin
     CurrentSection:=ExtractWord(1,s,[qBracket1,qBracket2]);
{     if Trim(CurrentSection,SpaceChars)='' then CurrentSection:=StrPas(snDefault);}
     x:=ExistSection(CurrentSection);
     if x<0 then
      begin
       New(iss,Init(CurrentSection));
       SecCol^.Insert(iss);
      end
     else iss:=SecCol^.At(x);
     continue;
    end;
   if (iss=nil) then
    begin
     New(iss,Init(CurrentSection));
     SecCol^.Insert(iss);
    end;
    s:=Space+s+Space;
    vn:=Trim(ExtractWord(1,s,[Equation]),SpaceChars);
    if (Pos(Equation,s)=0) then v:='' else
    v:=Trim(Copy(s,Pos(Equation,s)+1,Length(s)),SpaceChars);
    iss^.AddKey(vn,v);
   end;
  Close(f);
  Modified:=False;
  LoadFileEx:=0;
 end;
{}
function tIniFile.SaveFile;
 var
  f: pStream;
  x: Integer;
  s1,s2: String;
 begin
  SaveFile:=1;
  ReallocStr(FileName,aFileName);
  f:=New(pBufStream,Init(aFileName,stCreate,BlockSize));
  with SecCol^ do if Count>0 then for x:=0 to Count-1 do with pIniSection(At(x))^ do
   begin
    if (Trim(GetPS(Name),SpaceChars)<>'') then StreamWriteLn(f^,qBracket1+GetPS(Name)+qBracket2,cr+lf);
    FindValue(True,s1,s2);
    while not ValueError do
     begin
      if s2<>'' then StreamWriteLn(f^,s1+Equation+s2,cr+lf) else StreamWriteLn(f^,s1,cr+lf);
      FindValue(False,s1,s2)
     end;
{    if Count-1<>x then StreamWriteLn(f^,'',cr+lf);}
   end;
  DisposeObj(f);
  SaveFile:=0;
 end;
{}
function tIniFile.SaveFileEx;
 var
  f: Text;
  x: Integer;
  s1,s2: String;
 begin
  SaveFileEx:=1;
  ReallocStr(FileName,aFileName);
  Assign(f,aFileName);
  Rewrite(f);
  with SecCol^ do if Count>0 then for x:=0 to Count-1 do with pIniSection(At(x))^ do
   begin
    if (Trim(GetPS(Name),SpaceChars)<>'') then Write(f,qBracket1+GetPS(Name)+qBracket2,cr+lf);
    FindValue(True,s1,s2);
    while not ValueError do
     begin
      if s2<>'' then Write(f,s1+Equation+s2,cr+lf) else Write(f,s1,cr+lf);
      FindValue(False,s1,s2)
     end;
{    if Count-1<>x then StreamWriteLn(f^,'',cr+lf);}
   end;
  Close(f);
  SaveFileEx:=0;
 end;
{}
function tIniFile.ExistSection;
 var
  x: Integer;
 begin
{  if (Trim(SectionName,SpaceChars)='') then SectionName:=StrPas(snDefault);}
  with SecCol^ do if Count>0 then for x:=0 to Count-1 do with pIniSection(At(x))^ do
  if (UpStr(GetPS(Name))=UpStr(SectionName)) then
   begin
    ExistSection:=x;
    exit;
   end;
  ExistSection:=-1;
 end;
{}
function tIniFile.ExistValue;
 var
  x: Integer;
 begin
  ExistValue:=False;
{  if (Trim(SectionName,SpaceChars)='') then SectionName:=StrPas(snDefault);}
  x:=ExistSection(SectionName);
  if x<0 then exit;
  with pIniSection(SecCol^.At(x))^ do
   begin
    x:=ExistValue(ValueName);
    if x<0 then exit;
   end;
  ExistValue:=x>=0;
 end;
{}
procedure tIniFile.FindSection;
 begin
  if First then cs:=-1;
  Inc(cs);
  SectionName:='';
  with SecCol^ do if Count-1>=cs then
   begin
    SectionName:=GetPS(pIniSection(At(cs))^.Name);
    SectionError:=False;
   end
  else SectionError:=True;
 end;
{}
procedure tIniFile.FindValue;
 var
  x: Integer;
  bg: Boolean;
 begin
  x:=ExistSection(SectionName);
  ValueError:=True;
  ValueName:=CommaPoint;
  if x<>-1 then with pIniSection(SecCol^.At(x))^ do
   begin
    FindValue(First,ValueName,Value);
    if ValueError then exit;
    if ValueName='' then ValueName:=Space;
    if (ValueName[1]=CommaPoint) or (ValueName=Space) then
    while (not ValueError) and ((ValueName[1]=CommaPoint) or (ValueName=Space)) do
     begin
      FindValue(False,ValueName,Value);
      if ValueName='' then ValueName:=Space;
     end;
   end;
  if x<>-1 then ValueError:=pIniSection(SecCol^.At(x))^.ValueError;
  if ValueName=Space then ValueName:='';
 end;
{}
function tIniFile.ReadBoolean;
 begin
  ReadBoolean:=UpStr(ReadString(SectionName,ValueName))=UpStr(StrPas(iTrue));
 end;
{}
function tIniFile.ReadInteger;
 begin
  ReadInteger:=CToN(ReadString(SectionName,ValueName));
 end;
{}
function tIniFile.ReadString;
 var
  x: Integer;
  s: String;
 begin
  ReadString:='';
{  if (Trim(SectionName,SpaceChars)='') then SectionName:=StrPas(snDefault);}
  x:=ExistSection(SectionName);
  if x<0 then exit;
  with pIniSection(SecCol^.At(x))^ do
   begin
    x:=ExistValue(ValueName);
    if x<0 then exit;
    with pIniKey(KeyCol^.At(x))^ do s:=GetPS(Value);
    ReadString:=s;
   end;
 end;
{}
procedure tIniFile.WriteBoolean;
 begin
  if aValue then WriteString(SectionName,ValueName,StrPas(iTrue))
  else WriteString(SectionName,ValueName,StrPas(iFalse))
 end;
{}
procedure tIniFile.WriteInteger;
 begin
  WriteString(SectionName,ValueName,NToC(aValue));
 end;
{}
procedure tIniFile.WriteString;
 var
  x: Integer;
  s: String;
  iss: pIniSection;
 begin
  Modified:=True;
{  if (Trim(SectionName,SpaceChars)='') then SectionName:=StrPas(snDefault);}
  x:=ExistSection(SectionName);
  aValue:=Trim(aValue,SpaceChars);
  if x<0 then
   begin
    New(iss,Init(SectionName));
    SecCol^.Insert(iss);
   end
  else iss:=SecCol^.At(x);
  with iss^ do
   begin
    x:=-1;
    if ValueName='' then ValueName:=Space;
    if (ValueName[1]<>CommaPoint) and (ValueName<>Space) or (aValue<>'') then x:=ExistValue(Trim(ValueName,SpaceChars));
    if ValueName=Space then ValueName:='';
    if x<0 then AddKey(ValueName,aValue) else with pIniKey(KeyCol^.At(x))^ do ReallocStr(Value,aValue);
   end;
 end;
{}
procedure tIniFile.DeleteValue;
 var
  x: Integer;
 begin
{  if (Trim(SectionName,SpaceChars)='') then SectionName:=StrPas(snDefault);}
  x:=ExistSection(SectionName);
  if x<0 then exit;
  with pIniSection(SecCol^.At(x))^ do
   begin
    x:=ExistValue(ValueName);
    if x<0 then exit;
    Modified:=True;
    KeyCol^.AtFree(x);
   end;
 end;
{}
procedure tIniFile.DeleteSection;
 var
  x: Integer;
 begin
{  if (Trim(SectionName,SpaceChars)='') then SectionName:=StrPas(snDefault);}
  x:=ExistSection(SectionName);
  if x>=0 then
   begin
    Modified:=True;
    SecCol^.AtFree(x);
   end;
 end;
{}
procedure tIniFile.DeleteSections;
 begin
  Modified:=True;
  SecCol^.FreeAll;
 end;
{( tIniFiles )}
constructor tIniFiles.Init;
 begin
  New(IniCol,Init(16,16));
  ValueError:=True;
  SectionError:=True;
 end;
{}
destructor  tIniFiles.Done;
 procedure SaveIni(p: Pointer); far;
  var
   IniFile: pIniFile absolute p;
  begin
   if IniFile<>nil then with IniFile^ do if Modified then SaveFileEx(GetPS(FileName));
  end;
 begin
  IniCol^.ForEach(@SaveIni);
  DisposeObj(IniCol);
 end;
{}
function tIniFiles.GetIniFileByName(IniFileName: String): pIniFile;

 function Match_(p: Pointer): Boolean; far;
  var
   IniFile: pIniFile absolute p;
  begin
   Match_:=(UpStr(GetPS(IniFile^.FileName))=UpStr(IniFileName));
  end;

 var
  IniFile: pIniFile;
 begin
  IniFile:=IniCol^.FirstThat(@Match_);

  if (IniFile=nil) then
   begin
    New(IniFile,Init);
    IniCol^.Insert(IniFile);
    IniFile^.LoadFileEx(IniFileName);
   end;
  GetIniFileByName:=IniFile;
 end;
{}
function tIniFiles.ExistSection;
 begin
  ExistSection:=GetIniFileByName(IniFileName)^.ExistSection(SectionName)<>-1;
 end;
{}
function tIniFiles.ExistValue;
 begin
  ExistValue:=GetIniFileByName(IniFileName)^.ExistValue(SectionName, ValueName);
 end;
{}
procedure tIniFiles.FindSection;
 var
  IniFile: pIniFile;
 begin
  IniFile:=GetIniFileByName(IniFileName);
  IniFile^.FindSection(First,SectionName);
  SectionError:=IniFile^.SectionError;
 end;
{}
procedure tIniFiles.FindValue;
 var
  IniFile: pIniFile;
 begin
  IniFile:=GetIniFileByName(IniFileName);
  IniFile^.FindValue(First,SectionName,ValueName,Value);
  ValueError:=IniFile^.ValueError;
 end;
{}
function tIniFiles.ReadBoolean;
 begin
  ReadBoolean:=GetIniFileByName(IniFileName)^.ReadBoolean(SectionName, ValueName);
 end;
{}
function tIniFiles.ReadInteger;
 begin
  ReadInteger:=GetIniFileByName(IniFileName)^.ReadInteger(SectionName, ValueName);
 end;
{}
function tIniFiles.ReadString;
 begin
  ReadString:=GetIniFileByName(IniFileName)^.ReadString(SectionName, ValueName);
 end;
{}
procedure tIniFiles.WriteBoolean;
 begin
  GetIniFileByName(IniFileName)^.WriteBoolean(SectionName,ValueName,aValue);
 end;
{}
procedure tIniFiles.WriteInteger;
 begin
  GetIniFileByName(IniFileName)^.WriteInteger(SectionName,ValueName,aValue);
 end;
{}
procedure tIniFiles.WriteString;
 begin
  GetIniFileByName(IniFileName)^.WriteString(SectionName,ValueName,aValue);
 end;
{}
procedure tIniFiles.DeleteValue;
 begin
  GetIniFileByName(IniFileName)^.DeleteValue(SectionName,ValueName);
 end;
{}
procedure tIniFiles.DeleteSection;
 begin
  GetIniFileByName(IniFileName)^.DeleteSection(SectionName);
 end;
{}
procedure tIniFiles.DeleteSections;
 begin
  GetIniFileByName(IniFileName)^.DeleteSections;
 end;
{}
end.
